{
    "$graph": [
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#readPair.yml/FilePair",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readPair.yml/FilePair/forward",
                                    "type": "File"
                                },
                                {
                                    "name": "#readPair.yml/FilePair/reverse",
                                    "type": "File"
                                },
                                {
                                    "name": "#readPair.yml/FilePair/seed",
                                    "type": {
                                        "type": "array",
                                        "items": "int"
                                    }
                                },
                                {
                                    "name": "#readPair.yml/FilePair/number",
                                    "type": {
                                        "type": "array",
                                        "items": "int"
                                    }
                                },
                                {
                                    "name": "#readPair.yml/FilePair/rep",
                                    "type": {
                                        "type": "array",
                                        "items": "int"
                                    }
                                },
                                {
                                    "name": "#readPair.yml/FilePair/seqid",
                                    "type": "string"
                                }
                            ]
                        }
                    ],
                    "id": "#readPair.yml"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/exec_path"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#readPair.yml/FilePair"
                    },
                    "id": "#main/fqSeqs"
                },
                {
                    "type": "string",
                    "id": "#main/out_fn"
                }
            ],
            "steps": [
                {
                    "requirements": [
                        {
                            "class": "EnvVarRequirement",
                            "envDef": [
                                {
                                    "envValue": "$(inputs.exec_path)",
                                    "envName": "PATH"
                                }
                            ]
                        },
                        {
                            "class": "InitialWorkDirRequirement",
                            "listing": [
                                {
                                    "entryname": "paths.txt",
                                    "entry": "${ var res = ''; for (var i = 0; i < inputs.mlstout.length; ++i) { res += inputs.mlstout[i].path + '\\n'; } return res; }"
                                }
                            ]
                        }
                    ],
                    "run": {
                        "class": "CommandLineTool",
                        "baseCommand": [
                            "collect_mlst.py"
                        ],
                        "arguments": [
                            "paths.txt"
                        ],
                        "inputs": [
                            {
                                "type": "string",
                                "id": "#main/collect_mlst_res/f016b2b6-7c28-4693-ba99-c559f3a2a735/exec_path"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#main/collect_mlst_res/f016b2b6-7c28-4693-ba99-c559f3a2a735/mlstout"
                            },
                            {
                                "type": "string",
                                "inputBinding": {
                                    "position": 2
                                },
                                "id": "#main/collect_mlst_res/f016b2b6-7c28-4693-ba99-c559f3a2a735/out_fn"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "*.tab"
                                },
                                "id": "#main/collect_mlst_res/f016b2b6-7c28-4693-ba99-c559f3a2a735/mlst_table"
                            }
                        ],
                        "id": "#main/collect_mlst_res/f016b2b6-7c28-4693-ba99-c559f3a2a735"
                    },
                    "in": [
                        {
                            "source": "#main/exec_path",
                            "id": "#main/collect_mlst_res/exec_path"
                        },
                        {
                            "source": "#main/mlst/mlstout",
                            "id": "#main/collect_mlst_res/mlstout"
                        },
                        {
                            "source": "#main/out_fn",
                            "id": "#main/collect_mlst_res/out_fn"
                        }
                    ],
                    "out": [
                        "#main/collect_mlst_res/mlst_table"
                    ],
                    "id": "#main/collect_mlst_res"
                },
                {
                    "in": [
                        {
                            "source": "#main/rename_contigs/contigs",
                            "id": "#main/mlst/contigs"
                        }
                    ],
                    "out": [
                        "#main/mlst/mlstout"
                    ],
                    "scatter": "#main/mlst/contigs",
                    "run": "#mlst.cwl",
                    "id": "#main/mlst"
                },
                {
                    "requirements": [
                        {
                            "class": "EnvVarRequirement",
                            "envDef": [
                                {
                                    "envValue": "$(inputs.exec_path)",
                                    "envName": "PATH"
                                }
                            ]
                        }
                    ],
                    "run": {
                        "class": "CommandLineTool",
                        "baseCommand": "move_contigs.sh",
                        "inputs": [
                            {
                                "type": "string",
                                "id": "#main/rename_contigs/2916b96c-35c2-4390-b445-8d59d445521f/exec_path"
                            },
                            {
                                "type": "string",
                                "inputBinding": {
                                    "position": 2
                                },
                                "id": "#main/rename_contigs/2916b96c-35c2-4390-b445-8d59d445521f/run_id"
                            },
                            {
                                "type": "File",
                                "inputBinding": {
                                    "position": 1
                                },
                                "id": "#main/rename_contigs/2916b96c-35c2-4390-b445-8d59d445521f/spades_contigs"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "*.fasta"
                                },
                                "id": "#main/rename_contigs/2916b96c-35c2-4390-b445-8d59d445521f/contigs"
                            }
                        ],
                        "id": "#main/rename_contigs/2916b96c-35c2-4390-b445-8d59d445521f"
                    },
                    "in": [
                        {
                            "source": "#main/exec_path",
                            "id": "#main/rename_contigs/exec_path"
                        },
                        {
                            "source": "#main/spades-fast/run_id",
                            "id": "#main/rename_contigs/run_id"
                        },
                        {
                            "source": "#main/spades-fast/assembly",
                            "id": "#main/rename_contigs/spades_contigs"
                        }
                    ],
                    "out": [
                        "#main/rename_contigs/contigs"
                    ],
                    "scatter": [
                        "#main/rename_contigs/spades_contigs",
                        "#main/rename_contigs/run_id"
                    ],
                    "scatterMethod": "dotproduct",
                    "id": "#main/rename_contigs"
                },
                {
                    "in": [
                        {
                            "source": "#main/unpack_output/read_pairs",
                            "valueFrom": "$(self.forward)",
                            "id": "#main/spades-fast/forward_reads"
                        },
                        {
                            "source": "#main/unpack_output/read_pairs",
                            "valueFrom": "$(self.seqid)___$(self.number[0])-$(self.seed[0])-$(self.rep[0])___spades",
                            "id": "#main/spades-fast/output_dir"
                        },
                        {
                            "source": "#main/unpack_output/read_pairs",
                            "valueFrom": "$(self.reverse)",
                            "id": "#main/spades-fast/reverse_reads"
                        },
                        {
                            "valueFrom": "${return 8;}",
                            "id": "#main/spades-fast/threads"
                        }
                    ],
                    "out": [
                        "#main/spades-fast/assembly",
                        "#main/spades-fast/run_id"
                    ],
                    "scatter": [
                        "#main/spades-fast/forward_reads",
                        "#main/spades-fast/reverse_reads",
                        "#main/spades-fast/output_dir"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": "#spades-fast.cwl",
                    "id": "#main/spades-fast"
                },
                {
                    "in": [
                        {
                            "source": "#main/fqSeqs",
                            "valueFrom": "$(self.forward)",
                            "id": "#main/subsample/forward"
                        },
                        {
                            "source": "#main/fqSeqs",
                            "valueFrom": "$(self.number)",
                            "id": "#main/subsample/number"
                        },
                        {
                            "source": "#main/fqSeqs",
                            "valueFrom": "$(self.rep)",
                            "id": "#main/subsample/rep"
                        },
                        {
                            "source": "#main/fqSeqs",
                            "valueFrom": "$(self.reverse)",
                            "id": "#main/subsample/reverse"
                        },
                        {
                            "source": "#main/fqSeqs",
                            "valueFrom": "$(self.seed)",
                            "id": "#main/subsample/seed"
                        },
                        {
                            "source": "#main/fqSeqs",
                            "valueFrom": "$(self.seqid)",
                            "id": "#main/subsample/seqid"
                        }
                    ],
                    "scatter": [
                        "#main/subsample/forward",
                        "#main/subsample/reverse",
                        "#main/subsample/seqid",
                        "#main/subsample/seed",
                        "#main/subsample/number",
                        "#main/subsample/rep"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#main/subsample/resampled_fastq"
                    ],
                    "run": "#seqtk_sample_PE.cwl",
                    "id": "#main/subsample"
                },
                {
                    "run": {
                        "class": "ExpressionTool",
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "Any"
                                },
                                "id": "#main/unpack_output/64ae99e6-1e53-4c1f-85ba-53691a76fc3b/nested_read_pairs"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "#readPair.yml/FilePair"
                                },
                                "id": "#main/unpack_output/64ae99e6-1e53-4c1f-85ba-53691a76fc3b/read_pairs"
                            }
                        ],
                        "expression": "${\n    var ret=[];\n    for (var i = 0; i < inputs.nested_read_pairs.length; ++i) {\n        for (var j = 0; j < inputs.nested_read_pairs[i].length; ++j){\n        ret.push(inputs.nested_read_pairs[i][j]);\n        }\n    }\n    return { 'read_pairs' : ret }\n}\n",
                        "id": "#main/unpack_output/64ae99e6-1e53-4c1f-85ba-53691a76fc3b"
                    },
                    "in": [
                        {
                            "source": "#main/subsample/resampled_fastq",
                            "id": "#main/unpack_output/nested_read_pairs"
                        }
                    ],
                    "out": [
                        "#main/unpack_output/read_pairs"
                    ],
                    "id": "#main/unpack_output"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/collect_mlst_res/mlst_table",
                    "id": "#main/mlst_collection"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "mlst",
            "stdout": "${ var splitAll = function (str) { return str.split('\\\\').pop().split('/').reverse()[0].replace(/___\\w+$/g, '___mlst'); }; var dir = splitAll(inputs.contigs.location); return dir; }",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#mlst.cwl/contigs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#mlst.cwl/mlstout",
                    "outputBinding": {
                        "glob": "${ var splitAll = function (str) { return str.split('\\\\').pop().split('/').reverse()[0].replace(/___\\w+$/g, '___mlst'); }; var dir = splitAll(inputs.contigs.location); return dir; }"
                    }
                }
            ],
            "id": "#mlst.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "seqtk",
                "sample"
            ],
            "stdout": "$(inputs.seqid)___$(inputs.number)-$(inputs.seed)-$(inputs.rep)___R$(inputs.read_number).fq",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#seqtk_sample.cwl/fastq"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#seqtk_sample.cwl/number"
                },
                {
                    "type": "int",
                    "id": "#seqtk_sample.cwl/read_number"
                },
                {
                    "type": "int",
                    "id": "#seqtk_sample.cwl/rep"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-s",
                        "position": 1
                    },
                    "id": "#seqtk_sample.cwl/seed"
                },
                {
                    "type": "string",
                    "id": "#seqtk_sample.cwl/seqid"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#seqtk_sample.cwl/seqtkout",
                    "outputBinding": {
                        "glob": "$(inputs.seqid)___$(inputs.number)-$(inputs.seed)-$(inputs.rep)___R$(inputs.read_number).fq"
                    }
                }
            ],
            "id": "#seqtk_sample.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "$import": "#readPair.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#seqtk_sample_PE.cwl/forward"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#seqtk_sample_PE.cwl/number"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#seqtk_sample_PE.cwl/rep"
                },
                {
                    "type": "File",
                    "id": "#seqtk_sample_PE.cwl/reverse"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#seqtk_sample_PE.cwl/seed"
                },
                {
                    "type": "string",
                    "id": "#seqtk_sample_PE.cwl/seqid"
                }
            ],
            "outputs": [
                {
                    "type": "#readPair.yml/FilePair",
                    "outputSource": "#seqtk_sample_PE.cwl/collect_output/fastq_pair_out",
                    "id": "#seqtk_sample_PE.cwl/resampled_fastq"
                }
            ],
            "steps": [
                {
                    "run": {
                        "class": "ExpressionTool",
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#seqtk_sample_PE.cwl/collect_output/0006a2f8-7aae-4980-b085-0d072883e69e/seq_1"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "id": "#seqtk_sample_PE.cwl/collect_output/0006a2f8-7aae-4980-b085-0d072883e69e/seq_2"
                            },
                            {
                                "type": "string",
                                "id": "#seqtk_sample_PE.cwl/collect_output/0006a2f8-7aae-4980-b085-0d072883e69e/seqid"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "#readPair.yml/FilePair",
                                "id": "#seqtk_sample_PE.cwl/collect_output/0006a2f8-7aae-4980-b085-0d072883e69e/fastq_pair_out"
                            }
                        ],
                        "expression": "${\n    var ret=[];\n    for (var i = 0; i < inputs.seq_1.length; ++i) {\n        var tmp = {}\n        tmp['forward'] = inputs.seq_1[i];\n        tmp['reverse'] = inputs.seq_2[i];\n        tmp['seqid'] = inputs.seqid;\n        tmp['seed'] = [inputs.seed[i]];\n        tmp['number'] = [inputs.number[i]];\n        tmp['rep'] = [inputs.rep[i]];\n        ret.push(tmp);\n    }\n    return { 'fastq_pair_out' : ret }\n}\n",
                        "id": "#seqtk_sample_PE.cwl/collect_output/0006a2f8-7aae-4980-b085-0d072883e69e"
                    },
                    "in": [
                        {
                            "source": "#seqtk_sample_PE.cwl/number",
                            "id": "#seqtk_sample_PE.cwl/collect_output/number"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/rep",
                            "id": "#seqtk_sample_PE.cwl/collect_output/rep"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/seed",
                            "id": "#seqtk_sample_PE.cwl/collect_output/seed"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/subsample_1/seqtkout",
                            "id": "#seqtk_sample_PE.cwl/collect_output/seq_1"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/subsample_2/seqtkout",
                            "id": "#seqtk_sample_PE.cwl/collect_output/seq_2"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/seqid",
                            "id": "#seqtk_sample_PE.cwl/collect_output/seqid"
                        }
                    ],
                    "out": [
                        "#seqtk_sample_PE.cwl/collect_output/fastq_pair_out"
                    ],
                    "id": "#seqtk_sample_PE.cwl/collect_output"
                },
                {
                    "in": [
                        {
                            "source": "#seqtk_sample_PE.cwl/forward",
                            "id": "#seqtk_sample_PE.cwl/subsample_1/fastq"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/number",
                            "id": "#seqtk_sample_PE.cwl/subsample_1/number"
                        },
                        {
                            "valueFrom": "${return 1;}",
                            "id": "#seqtk_sample_PE.cwl/subsample_1/read_number"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/rep",
                            "id": "#seqtk_sample_PE.cwl/subsample_1/rep"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/seed",
                            "id": "#seqtk_sample_PE.cwl/subsample_1/seed"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/seqid",
                            "id": "#seqtk_sample_PE.cwl/subsample_1/seqid"
                        }
                    ],
                    "scatter": [
                        "#seqtk_sample_PE.cwl/subsample_1/seed",
                        "#seqtk_sample_PE.cwl/subsample_1/number",
                        "#seqtk_sample_PE.cwl/subsample_1/rep"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#seqtk_sample_PE.cwl/subsample_1/seqtkout"
                    ],
                    "run": "#seqtk_sample.cwl",
                    "id": "#seqtk_sample_PE.cwl/subsample_1"
                },
                {
                    "in": [
                        {
                            "source": "#seqtk_sample_PE.cwl/reverse",
                            "id": "#seqtk_sample_PE.cwl/subsample_2/fastq"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/number",
                            "id": "#seqtk_sample_PE.cwl/subsample_2/number"
                        },
                        {
                            "valueFrom": "${return 2;}",
                            "id": "#seqtk_sample_PE.cwl/subsample_2/read_number"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/rep",
                            "id": "#seqtk_sample_PE.cwl/subsample_2/rep"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/seed",
                            "id": "#seqtk_sample_PE.cwl/subsample_2/seed"
                        },
                        {
                            "source": "#seqtk_sample_PE.cwl/seqid",
                            "id": "#seqtk_sample_PE.cwl/subsample_2/seqid"
                        }
                    ],
                    "scatter": [
                        "#seqtk_sample_PE.cwl/subsample_2/seed",
                        "#seqtk_sample_PE.cwl/subsample_2/number",
                        "#seqtk_sample_PE.cwl/subsample_2/rep"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#seqtk_sample_PE.cwl/subsample_2/seqtkout"
                    ],
                    "run": "#seqtk_sample.cwl",
                    "id": "#seqtk_sample_PE.cwl/subsample_2"
                }
            ],
            "id": "#seqtk_sample_PE.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "spades-fast",
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "coresMin": 2,
                    "coresMax": 8
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--R1",
                        "position": 1
                    },
                    "id": "#spades-fast.cwl/forward_reads"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "--gsize",
                        "position": 3
                    },
                    "id": "#spades-fast.cwl/genome_size"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--kmers",
                        "position": 3
                    },
                    "id": "#spades-fast.cwl/kmers"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--outdir",
                        "position": 4
                    },
                    "id": "#spades-fast.cwl/output_dir"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--R2",
                        "position": 2
                    },
                    "id": "#spades-fast.cwl/reverse_reads"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "--cpus",
                        "position": 3
                    },
                    "id": "#spades-fast.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)/contigs.fasta"
                    },
                    "id": "#spades-fast.cwl/assembly"
                },
                {
                    "type": "string",
                    "outputBinding": {
                        "outputEval": "${ return inputs.output_dir; }"
                    },
                    "id": "#spades-fast.cwl/run_id"
                }
            ],
            "id": "#spades-fast.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
